#define _WIN32_IE 0x0500
#include <string>
#include <windows.h>
#include <commctrl.h>
#include "Recursos.h"
#include <mysql/mysql.h>
  
bool BaseDatos::CrearBaseDatos (HWND hwnd, char *NBD, char *maquina, char *login, char *clave)
{
  char cadena[151];
  
  strcpy(Maquina, maquina);
  strcpy(Nombrebase, NBD);
  
  if (!(MisDatos = mysql_init(0))){
      sprintf(cadena, "Error : %s", mysql_error(MisDatos));  
      MessageBox (hwnd, cadena, "Chanchich", MB_ICONEXCLAMATION);  
      return false;  
  }  
  /*if (ExisteBD()){
      MessageBox (hwnd, "La Base de Datos ya existe", "Chanchich", MB_ICONEXCLAMATION);  
      return false;        
  }*/  
  if (!mysql_real_connect(MisDatos, maquina, login, clave, NULL, MYSQL_PORT, NULL, 0)){      
      mysql_close(MisDatos);
      sprintf(cadena, "Error : %s", mysql_error(MisDatos));
      MessageBox (hwnd, cadena, "Chanchich", MB_ICONEXCLAMATION);
      return false;  
  }
  /* Se empieza a crear la base de datos*/
  mysql_query(MisDatos, "CREATE DATABASE Restorant");
  mysql_query(MisDatos, "CREATE TABLE Restorant.Usuarios ("
                        "rut VARCHAR(15), " 
                        "nombre VARCHAR(30), "
                        "apellidos VARCHAR(30), "
                        "direccion VARCHAR(50), "
                        "fono VARCHAR(15), "
                        "email VARCHAR(40), "
                        "cargo VARCHAR(30), "
                        "login VARCHAR(20), "
                        "clave VARCHAR(15), "
                        "permisos INT NOT NULL DEFAULT 0, "
                        "nacimiento DATE, "
                        "PRIMARY KEY (rut)) "
                        "ENGINE=InnoDB");
  if (!ExisteTabla(MisDatos, "Restorant", "Usuarios")){
     mysql_close(MisDatos);   
     sprintf(cadena, "Error : %s", mysql_error(MisDatos));
     MessageBox (hwnd, cadena, "Usuarios", MB_ICONEXCLAMATION);   
     return false;
  }   
  mysql_query(MisDatos, "CREATE TABLE Restorant.Productos ("
                        "codigo VARCHAR(15), "
                        "descripcion VARCHAR(50), "
                        "tipo VARCHAR(20), "
                        "medida VARCHAR (15), "                        
                        "PRIMARY KEY (codigo)) "
                        "ENGINE=InnoDB");
  if (!ExisteTabla(MisDatos, "Restorant", "Productos")){
     mysql_close(MisDatos);
     sprintf(cadena, "Error : %s", mysql_error(MisDatos));
     MessageBox (hwnd, cadena, "Productos", MB_ICONEXCLAMATION);   
     return false;
  }
  mysql_query(MisDatos, "CREATE TABLE Restorant.Fifo ("
                        "codigoProducto VARCHAR(15), "                        
                        "cantidad INT NOT NULL DEFAULT 0, "
                        "pesolitro FLOAT(4) NOT NULL DEFAULT 1, "
                        "fingreso DATE, "
                        "fvencimiento DATE, "
                        "pcosto INT NOT NULL DEFAULT 0, "
                        "codigoFifo INT AUTO_INCREMENT, "
                        "PRIMARY KEY (codigoFifo), "
                        "FOREIGN KEY (codigoProducto) REFERENCES Productos (codigo) "
                        "ON DELETE CASCADE ON UPDATE CASCADE) "
                        "ENGINE=InnoDB");
  if (!ExisteTabla(MisDatos, "Restorant", "Fifo")){        
     mysql_close(MisDatos);
     sprintf(cadena, "Error : %s", mysql_error(MisDatos));
     MessageBox (hwnd, cadena, "Fifo", MB_ICONEXCLAMATION);   
     return false;
  }       
  mysql_query(MisDatos, "CREATE TABLE Restorant.Menu ("
                        "codigo VARCHAR(15), "
                        "descripcion VARCHAR(50), "
                        "precioneto INT NOT NULL DEFAULT 0, "
                        "PRIMARY KEY (codigo)) "
                        "ENGINE=InnoDB");
  if (!ExisteTabla(MisDatos, "Restorant", "Menu")){
     mysql_close(MisDatos);
     sprintf(cadena, "Error : %s", mysql_error(MisDatos));
     MessageBox (hwnd, cadena, "Men", MB_ICONEXCLAMATION);
     return false;
  }       
  mysql_query(MisDatos, "CREATE TABLE Restorant.Recetas ("
                        "codigomenu VARCHAR(15), "
                        "codigoingrediente VARCHAR(15), "
                        "Descripcion VARCHAR(30), "
                        "FOREIGN KEY (codigomenu) REFERENCES Menu (codigo) "
                        "ON DELETE CASCADE ON UPDATE CASCADE) "
                        "ENGINE=InnoDB");
  if (!ExisteTabla(MisDatos, "Restorant", "Recetas")){
     mysql_close(MisDatos);
     sprintf(cadena, "Error : %s", mysql_error(MisDatos));
     MessageBox (hwnd, cadena, "Recetas", MB_ICONEXCLAMATION);   
     return false;
  }        
  mysql_query(MisDatos, "CREATE TABLE Restorant.Ingredientes ("
                        "codigoingrediente VARCHAR(15), "
                        "codigoproducto VARCHAR(15), "
                        "cantidad INT NOT NULL DEFAULT 1, "
                        "pesolitro FLOAT(4) NOT NULL DEFAULT 1, "
                        "PRIMARY KEY (codigoingrediente), "
                        "FOREIGN KEY (codigoproducto) REFERENCES Productos (codigo) "
                        "ON DELETE CASCADE ON UPDATE CASCADE) "
                        "ENGINE=InnoDB");
  if (!ExisteTabla(MisDatos, "Restorant", "Ingredientes")){
     mysql_close(MisDatos);
     sprintf(cadena, "Error : %s", mysql_error(MisDatos));
     MessageBox (hwnd, cadena, "Ingredientes", MB_ICONEXCLAMATION);
     return false;
  }      
  mysql_query(MisDatos, "CREATE TABLE Restorant.Boletas ("
                        "nroboleta VARCHAR(15), "
                        "femision DATE, "
                        "iva INT NOT NULL DEFAULT 19, "
                        "montototal INT NOT NULL DEFAULT 0, "
                        "descuento INT NOT NULL DEFAULT 0, "
                        "valido INT NOT NULL DEFAULT 1, "
                        "tipodescuento VARCHAR(15), "
                        "PRIMARY KEY (nroboleta)) "
                        "ENGINE=InnoDB");
  if (!ExisteTabla(MisDatos, "Restorant", "Boletas")){
     mysql_close(MisDatos);
     sprintf(cadena, "Error : %s", mysql_error(MisDatos));
     MessageBox (hwnd, cadena, "Boletas", MB_ICONEXCLAMATION);
     return false;
  }       
  mysql_query(MisDatos, "CREATE TABLE Restorant.Detalle ("
                        "nroboleta VARCHAR(15), "
                        "codigomenu VARCHAR(15), "
                        "femision DATE, "
                        "FOREIGN KEY (nroboleta) REFERENCES Boletas (nroboleta) "
                        "ON DELETE CASCADE ON UPDATE CASCADE) "
                        "ENGINE=InnoDB");
  if (!ExisteTabla(MisDatos, "Restorant", "Detalle")){
     mysql_close(MisDatos);
     sprintf(cadena, "Error : %s", mysql_error(MisDatos));
     MessageBox (hwnd, cadena, "Detalle", MB_ICONEXCLAMATION);
     return false;
  }   
  mysql_close(MisDatos);
  return true;                        
}

bool BaseDatos::ExisteBD()
{
    char *Consul;
    char *cadena = "SHOW DATABASES LIKE \'%s\'";
    MYSQL_RES *res;
    bool valor = true;

    Consul = new char [strlen(Nombrebase)+strlen(cadena)];
    sprintf(Consul, cadena, Nombrebase);

    if(!mysql_query(MisDatos, Consul)){
        if ((res = mysql_store_result(MisDatos))){
            if (!mysql_num_rows(res)) valor = false;
            mysql_free_result(res);
        }
    }
    delete[] Consul;
    return valor;
}

bool BaseDatos::ExisteTabla(MYSQL *MiDato, char *mibase, char *mitabla)
{
 char * consulta;
 char *plantilla = "SHOW TABLES FROM %s LIKE \'%s\'";
 MYSQL_RES *res;
 bool valorret = true;

 consulta = new char[strlen(mibase)+ strlen(mitabla)+ strlen(plantilla)-1];
 sprintf(consulta, plantilla, mibase, mitabla);

 if (!mysql_query(MiDato, consulta)){
    if ((res = mysql_store_result(MiDato))){
       if (!mysql_num_rows(res)) valorret = false;
       mysql_free_result(res);
    }
 }
 delete[] consulta;
 return valorret;
}

bool BaseDatos::GuardaUsuario(HWND hwnd, char *login, char *clave)
{
  int ancho;  
  char *Consulta;
  char Plantilla2[250];
  char cadena[] = "INSERT INTO Usuarios VALUES (\'%s\', \'%s\', \'%s\', \'%s\', \'%s\', \'%s\', \'%s\', \'%s\', \'%s\', \'%d\', \'%s\')";

  if (!(MisDatos = mysql_init(0))){
      return false;
  }
  if (!mysql_real_connect(MisDatos, Maquina, login, clave, Nombrebase, MYSQL_PORT, NULL, 0)){
      sprintf(Plantilla2, "Error : %s", mysql_error(MisDatos));
      MessageBox (hwnd, Plantilla2, "Chanchich", MB_ICONEXCLAMATION);
      mysql_close(MisDatos);
      return false;
  }
  /* Se formula consulta para ingresar datos*/
  ancho = strlen(usuario.rut) + strlen(usuario.nombre) + strlen(usuario.apellidos) + strlen(usuario.direccion);
  ancho = ancho + strlen(usuario.fono) + strlen(usuario.email) + strlen(usuario.cargo);
  ancho = ancho + strlen(usuario.login) + strlen (usuario.clave) + strlen(usuario.nacimiento) + 1; 
  Consulta = new char[strlen(cadena)+ ancho];
  sprintf(Consulta, cadena, usuario.rut, usuario.nombre, usuario.apellidos, usuario.direccion,
                            usuario.fono, usuario.email, usuario.cargo, usuario.login,
                            usuario.clave, usuario.permisos, usuario.nacimiento);
                              
  mysql_query(MisDatos, Consulta);
  delete[] Consulta;
  mysql_close(MisDatos);
  return true;
}

bool BaseDatos::GuardaProducto(HWND hwnd, char *login, char *clave)
{
  int ancho;
  char *Consulta;
  char Plantilla2[250];
  char cadena[] = "INSERT INTO Productos VALUES (\'%s\', \'%s\', \'%s\', \'%s\')";

  if (!(MisDatos = mysql_init(0))){
      return false;
  }
  if (!mysql_real_connect(MisDatos, Maquina, login, clave, Nombrebase, MYSQL_PORT, NULL, 0)){
      sprintf(Plantilla2, "Error : %s", mysql_error(MisDatos));
      MessageBox (hwnd, Plantilla2, "Chanchich", MB_ICONEXCLAMATION);
      mysql_close(MisDatos);
      return false;
  }
  /* Se formula consulta para ingresar datos*/
  ancho = strlen(producto.codigo) + strlen(producto.descripcion) + strlen(producto.tipo);
  ancho = ancho + strlen(producto.medida) + 4;
  Consulta = new char[strlen(cadena)+ ancho];
  sprintf(Consulta, cadena, producto.codigo, producto.descripcion, producto.tipo, producto.medida);

  mysql_query(MisDatos, Consulta);
  delete[] Consulta;
  mysql_close(MisDatos);
  return true;
}

bool BaseDatos::GuardaFifo(HWND hwnd, char *login, char *clave)
{
  int ancho;
  char *Consulta;
  char Plantilla2[250];
  char cadena[] = "INSERT INTO Fifo VALUES (\'%s\', \'%d\', \'%f\', \'%s\', \'%s\', \'%d\', 0)";

  if (!(MisDatos = mysql_init(0))){
      return false;
  }
  if (!mysql_real_connect(MisDatos, Maquina, login, clave, Nombrebase, MYSQL_PORT, NULL, 0)){
      sprintf(Plantilla2, "Error : %s", mysql_error(MisDatos));
      MessageBox (hwnd, Plantilla2, "Chanchich", MB_ICONEXCLAMATION);
      mysql_close(MisDatos);
      return false;
  }
  /* Se formula consulta para ingresar datos*/
  ancho = strlen(fifo.codigoProducto);
  ancho = ancho + strlen(fifo.fingreso) + strlen(fifo.fvencimiento) + 19;
  Consulta = new char[strlen(cadena)+ ancho];
  sprintf(Consulta, cadena, fifo.codigoProducto, fifo.cantidad, fifo.pesolitro,
                            fifo.fingreso, fifo.fvencimiento, fifo.pcosto);

  mysql_query(MisDatos, Consulta);
  sprintf(Plantilla2, "Error : %s", mysql_error(MisDatos));
  MessageBox (hwnd, Plantilla2, "Chanchich", MB_ICONEXCLAMATION);
  delete[] Consulta;
  mysql_close(MisDatos);
  return true;
}

void BaseDatos::ObtieneUsuario(Usuario *dato){
  strcpy(usuario.rut,dato->rut);
  strcpy(usuario.nombre,dato->nombre);
  strcpy(usuario.apellidos,dato->apellidos);
  strcpy(usuario.direccion,dato->direccion);
  strcpy(usuario.fono,dato->fono);
  strcpy(usuario.email,dato->email);
  strcpy(usuario.cargo,dato->cargo);
  strcpy(usuario.login,dato->login);
  strcpy(usuario.clave,dato->clave);
  strcpy(usuario.nacimiento,dato->nacimiento);
  usuario.permisos = dato->permisos;
}

void BaseDatos::ObtieneProducto(Producto *dato){
  strcpy(producto.codigo, dato->codigo);
  strcpy(producto.descripcion, dato->descripcion);
  strcpy(producto.tipo, dato->tipo);
  strcpy(producto.medida, dato->medida);  
}

void BaseDatos::ObtieneFifo(Fifo *dato){
  strcpy(fifo.codigoProducto,dato->codigoProducto);  
  strcpy(fifo.fingreso,dato->fingreso);
  strcpy(fifo.fvencimiento,dato->fvencimiento);
  fifo.cantidad = dato->cantidad;
  fifo.pesolitro = dato->pesolitro;
  fifo.pcosto = dato->pcosto;
}
    

bool BaseDatos::BuscarList(HWND hwnd, char *usuario, char *clave, char *dato, int IDC)
{ 
  HWND ListView;
  char *Consulta;    
  char Mensaje[90];
  MYSQL_ROW Campos;
  char muestra[260]; 
  MYSQL_RES *respuesta = NULL;
  int ancho, total, indice, i, j;
  
  if (!(MisDatos = mysql_init(0))){
      return false;
  }
  if (!mysql_real_connect(MisDatos, Maquina, usuario, clave, Nombrebase, MYSQL_PORT, NULL, 0)){
      sprintf(Mensaje, "Error : %s", mysql_error(MisDatos));
      MessageBox (hwnd, Mensaje, "Chanchich", MB_ICONEXCLAMATION);
      mysql_close(MisDatos);
      return false;
  }
  /* Se formula consulta para leer datos*/
  ancho = strlen(Plantilla) + strlen(dato);
  Consulta = new char[ancho];
  sprintf(Consulta, Plantilla, dato);
  
  mysql_query(MisDatos, Consulta);
  ListView = GetDlgItem(hwnd, IDC);
  
  ListView_DeleteAllItems(ListView);  
  
  if ((respuesta = mysql_store_result(MisDatos))){
     total = (int) mysql_num_rows(respuesta);
          
     UsarGrillas(ListView);
    
     for (i=0;i<total; ++i){
        Campos = mysql_fetch_row(respuesta);
        AgregarItem(ListView, Campos[InfoColumnas.SelecCol[0]], i);
        for (j=1;j<InfoColumnas.NColumnas;++j)        
            AgregarSubItem(ListView, i, j, Campos[InfoColumnas.SelecCol[j]]);

     }
     mysql_free_result(respuesta);
     delete[] Consulta;
     mysql_close(MisDatos);
     return true;
  }
  return false;
}

void BaseDatos::AgregarItem(HWND LVHandle, LPSTR lpszTexto, int nIndice){
char szbuffer[260];

     lstrcpy(szbuffer,lpszTexto);
     lstrcat(szbuffer, "\0");
     Item.pszText = szbuffer;
     Item.cchTextMax = sizeof (szbuffer);
     Item.mask = LVIF_TEXT | LVIF_IMAGE;
     Item.iItem = nIndice;
     ListView_InsertItem (LVHandle, &Item);
     ListView_Update (LVHandle, nIndice);
}

void BaseDatos::AgregarSubItem(HWND LVHandle, int nIndiceItem, int nIndiceSubItem, LPSTR lpszTexto){
LV_ITEM lv;
char szbuffer[260];

     lstrcpy(szbuffer,lpszTexto);
     lstrcat(szbuffer, "\0");
     lv.iSubItem = nIndiceSubItem;
     lv.pszText = szbuffer;
     SendMessage (LVHandle, LVM_SETITEMTEXT, (WPARAM) (int) nIndiceItem, (LPARAM) (LV_ITEM FAR *) &lv);     
}

void BaseDatos::AgregarColumna(HWND LVHandle, LPSTR lpszTexto, int nAncho, int nIndice){
	lvCol.cchTextMax = 260;
	lvCol.pszText = lpszTexto;
	lvCol.mask = LVCF_TEXT | LVCF_WIDTH;
	lvCol.cx = nAncho;
	ListView_InsertColumn(LVHandle, nIndice, &lvCol);
}

void BaseDatos::UsarGrillas(HWND LVHandle){
	SendMessage(LVHandle, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, (LPARAM)LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT);
}

void BaseDatos::TextoColumnas(char *texto, int Index, int ancho, int seleccion)
{
   strcpy(InfoColumnas.TextoCol[Index], texto);
   InfoColumnas.AnchoCol[Index] = ancho;
   InfoColumnas.SelecCol[Index] = seleccion;   
}

void BaseDatos::FijarColum(int Numcol)
{
  InfoColumnas.NColumnas = Numcol;  
}

void BaseDatos::LlenarColumnas(HWND ListV)
{
 int i;   
 for (i=0;i<InfoColumnas.NColumnas;++i)   
     AgregarColumna (ListV, InfoColumnas.TextoCol[i], InfoColumnas.AnchoCol[i], i);
 return;    
}

void BaseDatos::PlantillaQuery(char *aux){
    strcpy(Plantilla, aux);
}

void BaseDatos::BaseMaquina(char *nbd, char *servidor){
    strcpy(Nombrebase,nbd);
    strcpy(Maquina,servidor);
}
